import os

import click
from tutor import commands as tutor_commands
from tutor import config as tutor_config
from tutor import fmt, hooks
from tutor import serialize as tutor_serialize

PRESERVED_CONFIG_FILENAME = "grove-preserved-config.yml"


def save_config(root, name, config):
    """
    Save a YAML configuration file to the given root directory.
    """
    config_path = os.path.join(root, name)
    with open(config_path, "w", encoding="utf-8") as of:
        tutor_serialize.dump(config, of)


def update_with(root, name, config):
    """
    Update the given configuration with the values from the configuration file at the given path.
    """
    config_to_update_with_path = os.path.join(root, name)
    if not os.path.exists(config_to_update_with_path):
        return

    config_to_update_with = tutor_config.get_yaml_file(config_to_update_with_path)
    tutor_config.merge(config, config_to_update_with)


def get_unique_config_keys():
    """
    Returns the keys of the configuration values that are unique and generated by Tutor, like random passwords,
    private keys, unuqie IDs, etc.

    Some of these values come from the base Tutor configuration (hence manipulations with the base config),
    others are defined by the CONFIG_UNIQUE filter.
    """
    tutor_base_configs = tutor_config.get_base()
    extra_config = hooks.Filters.CONFIG_OVERRIDES.apply([])
    exclude_keys = {name for name, _ in extra_config} | {"PLUGINS", "PLUGIN_INDEXES"}
    return set(tutor_base_configs.keys()) - exclude_keys


def save_unique_config(root):
    """
    Saves the unique configuration values in a separate file.
    """
    existing_config = tutor_config.load_minimal(root)
    unique_config = {key: existing_config[key] for key in get_unique_config_keys()}
    save_config(root, PRESERVED_CONFIG_FILENAME, unique_config)
    fmt.echo_info(f"Saved unique configuration in {os.path.join(root, PRESERVED_CONFIG_FILENAME)}")


@click.command(help="Wrapper around `tutor config save` that does some additional steps before and after saving")
@click.pass_context
def grove_config_save(context):
    """
    This command is a wrapper around `tutor config save` that does some additional steps before and after saving the
    configuration.

    Before saving the configuration, it:
    - Updates the user-provided config.yml (the one we keep in the repository) with values from the "preserved config"
      file.

    After saving the configuration, it:
    - Saves the unique configuration to the "preserved config" file. Grove stores it in S3 and sync it before and
      after running this command.

    We need to do this because we don't want Tutor to re-generate the unique configuration (like unique random
    passwords, private keys, etc.) every time we re-deploy an instance.
    """
    root = context.obj.root

    user_config_path = os.path.join(root, tutor_config.CONFIG_FILENAME)
    user_config = tutor_config.get_yaml_file(user_config_path)

    update_with(root, PRESERVED_CONFIG_FILENAME, user_config)
    save_config(root, tutor_config.CONFIG_FILENAME, user_config)
    fmt.echo_info(f"Updated {user_config_path} with preserved configuration")

    context.forward(tutor_commands.config.save)

    save_unique_config(root)
